Fronteers 2010, Day 1
=====================

<div style="float:left;width:400px;height:200px;background:red;">SUPERVET</div>

The Design of HTML5
===================
By [Jeremy Keith](http://www.adactio.com) [@adactio](http://www.twitter.com/adactio)

* "Design principles"
    * As in vision, see e.g Karl Marx and Declaration of Independence
    * "Four legs good, two legs bad" - George Orwell
    * Isaac Asimov’s three rules of robotics
* Tim Berners-Lee's design principle: decentralization / independence
* **Postel's law** is the design principle for html5:
    > Be conservative in what you send, be liberal in what you accept

* Both W3C and WHATWG working on HTML5 is good because they're both good at different things
* [W3C HTML design principles](http://w3.org/TR/html-design-principles)
* HTML5 is not about theoretical solutions, but about practice
* HTML5: `type="text/css"` not needed on `<link>` element
* [HTML lint](http://www.htmllint.com)
* "pave the cowpaths" (use existing solutions)
* `<footer>` doesn't have to be at the bottom:

        <article>
            <p>blabla</p>
            <footer>By Mr. X</footer>
        </article>

* `<h1>` can be used in every new node of the DOM tree:

        <article>
            <h1>bla</h1>
            <section>
                <h1>bla</h1>
            </section>
        </article>

* `<input type="search" placeholder="Search here!" />`
* "Priority of constituencies"

    > In case of conflict, consider **users** over **authors** over
    > ** implementors** over **specifiers** over **theoretical purity**

* [Drupal 7 User Experience Project](d7ux.org)
* "Publish your design principles!"
* "Rough consensus and running code" (The Tao of IETF)
* [The Mozilla Manifesto](http://www.mozilla.org/about/manifesto.en.html)
* getAttribute() and the dot syntax don't give the same results for new `<input>` `type` attributes
* Not using HTML5 because of SEO reasons is BS.
* "SEO is like mierenneuken"
* ARIA roles in elements is valid in HTML5

## JavaScript - Like a box of chocolates - [Robert Nyman](http://robertnyman.com/) - [@robertnyman](http://twitter.com/robertnyman)
* *Robert's [CSS](http://robertnyman.com/css3/) and [HTML](http://robertnyman.com/html5) playgrounds*
* "Javascript was created by Brendan Eich in just 10 days." Then it took 15 years to mature :)

        [] instanceof Array; // true
        {} isntanceof Object; // false

* Type coercion: doing == first converts before comparison:

        7 == "7"; // true
        7 === "7"; / false

* From left to right, so:

        "5" + 6 + 7; // "567"

* "Self-invoking functions"

        (function() {
            // bla
        })();

* Optimization:

        for (var i = 0, l = items.length; i < l; i++)

* Handy:

        "flep" in { "flep" : "flap" }; // true

* Scope:

        function flep() {
            return this.nodeName;
        }
    
        flep();/ undefined
        flep.call(document, "Hello"); // #document
        flep.apply(document.body, ["Hello", "Greetings"]; // body

* `apply` accepts arguments in an array as the second parameter
* Closures:

        function flep(floep) {
            return function(flip) {
                return floep + flip;
            }
        }
    
        var flap = flep("floep");
        flap("flup"); // floep flup

* Fixing for loops

        var i = "flep";
        flep.onclick = function(index) {
            // "flep"
        }(i);

* YUI Javascript Module Pattern:

        var f = function() {
            var private = 'private',
                getPrivate = function() {
                    return private;
                }
    
            return {
                "getPrivate" : getPrivate
                "flep" : function() {
                    return Movie.forrest.getFirstName.call(this) + "iets anders";
                }
            };
        }();

* Ugly, but possible

        for (var i, l = items.length, blaat, floep, flip; i < l; i++)

* I'd rather have:

        var blaat, floep;
        for (var i = 0, l = items.length; l < i; i++)

Vector Graphics for the Web
===========================
By [Brad Neuberg](http://codinginparadise.org/) - [@bradneuberg](http://twitter.com/bradneuberg) [Ajaxian](http://ajaxian.com)
* "Small pieces loosely joined"
* [Ultracool presentation from Brad](http://codinginparadise.org/projects/html5-3d-slides/html5.html), currently Safari 5 only
* Google indexes SVG
* Use SVG when dynamic resizing is important
* You can use CSS to style SVG!
* [SVG Web compatibility library for IE](http://code.google.com/p/svgweb/)

## CSS3 - Håkon Wium Lie (CTO, Opera, creator CSS) - [Howcome](http://people.opera.com/howcome/)
* World Wide Web ca 1994: you click, we do the rest!
    
    > Nobody is ever going to use rounded corners
    
    > *Lie about CSS in 1994*
    
* `box-shadow: inset;`
* You can use fonts to include pictures :)
* [Nice web fonts](http://www.princexml.com/fonts/steffman/index.css)
* CSS3 Transitions:

        #trans {
            transition-duration: 1s;
        }
    
        #trans:hover {
            color: red;
            background: black;
            letter-spacing: 10px;
        }

* `float:top` en `float:bottom` can be used for paged media
* CSS3 for paged media:

        @page {
            @bottom-left {
                content: counter(page);
            }
    
            @bottom-right {
                content:
            }
        }
    
        title {
            string-set: title content();
        }

* Top countries using Opera mini:
    1. Indonesia
    2. Russia
    3. India
* Some non-international sites visited the most on Opera mini in Indonesia:
    1. [detik.com](http://detik.com)
    2. [waptrick.com](http://waptrick.com)
    3. [getjar.com](http://getjar.com)

Progressive Downloads and Rendering
===================================
By [Stoyan Stefanov](http://www.phpied.com) [@stoyanstefanov](http://twitter.com/stoyanstefanov) (Yahoo)
* [Performance blog aggregator](http://www.perfplanet.com)
* `defer` and `async` properties (for IE / html5)
* Use `<?php flush(); ?>` to do chunked encoding
* Provide chunks for header, body, footer, such as with Google Instant
* [Chunked encoding viewer](http://www.tinyurl.com/chunkview)
* Using inline CSS instead of `<link />` is faster, possibly using post-loading
* Conditional comments (IE) block all loading in IE. Put them around the `<html>`
  tag and use a class on the `<html>` element for hacks
* You can preload resources, such as with a login screen, for the next possible screen.
  This might be possible using the `preload` attribute in the `<link>` element
* Use the `data:uri` format to save on HTTP requests. This works in all browsers and IE8 and higher.
* For IE6 / IE7 use MHTML. [This has some quirks](http://www.phpied.com/inline-mhtml-data-uris/).
* It is possible to do a complete web app in one single HTTP request. (maybe not very pragmatic :)
    * You might use some kind of server-side browser sniffing for CSS stuff
    * And the weird Russian JPG base64 header hack to service it to both IE
      and other browsers (some voodoo happening here :)
* Animations can be used as distractions (see Google Instant)
* 50% of all users visiting a webpage don't have anything cached from that page

## CSS Workflow - [Jina Bolton](http://sushiandrobots.com/) - [@jina](http://twitter.com/#!/jina) (User Experience designer / [Engine Yard](http://www.engineyard.com)
* Sketch before code
* Create systems instead of pages

    > Be regular and orderly in your life so that you may be
    > violent and original in your work
    
    > *Gustave Flaubert*

* Use

        <div id="page">
            <!-- your site -->
        </div>

* Instead of

        <div id="wrapper">
            <!-- your site -->
        </div>

* [Microformats for Developers](http://webdirections.org/slides/MicroformatsForDevelopers.pdf)
* [Microformats for Designers](http://webdirections.org/slides/MicroformatsForDesigners.pdf)

Reusable code, for good or awesome
==================================
By </link>[Jake Archibald](http://www.jakearchibald.com/) [@jaffathecake](http://twitter.com/jaffathecake)
* Used to work at the BBC ([Glow JS library](http://www.bbc.co.uk/glow/)), now working at theTeam
* Steps for writing reusable component code:
    1. Define requirements
    2. Write feasibility code
    3. Write API before code
    4. Show code to others: can they understand what it does?
* Put functions in:
    * Namespace
        * Organize when necessary
    * Library plugin
* Don't put it in:
    * Object prototype (because of collisions later on)
    * Global vars (not namespaces)
* Jake Weary != jQuery
* jQuery.fn === jQuery.prototype
* Don't mix/match plugin vs namespace
* Jake on Java:

    > Like most things in the world, this is Java's fault
    
* [JSdoc toolkit (Rhino)](http://code.google.com/p/jsdoc-toolkit/) *also does option objects docs!*
* Send documentation around for evaluation before implementation
* Try to make arguments read well

        element.cloneNode(true); // what does 'true do?
        jToys.carousel('#whatever', undefined, 500); // what is undefined and 500?

* Make it simple for 80% of the use cases, but accommodate for the other 20%
  (e.g. `$.get` vs `$.ajax`)
* jQuery UI instances and methods are one way of doing it, but object instances are better:

        var carousel = new jToys.CarouselPane("#whatever", {
            //
        });
    
        carousel.moveTo().flep().flap();

* Add hooks to inner workings (using events)
* Aim for 1 line, 1 param usage
* [Frank's](http://twitter.com/frenkie) question: how do you accomplish multiple projects on one central codebase?
    * BBC had the same problem
    * You need a good tester
    * Use something like [RequireJS](http://requirejs.org/) and work with 'incremental versions', just like
      jQuery on Googleapis:

          http://ajax.googleapis.com/ajax/libs/jquery/1/jquery.min.js // Gives you the last '1' version (e.g. 1.4.2)
          http://ajax.googleapis.com/ajax/libs/jquery/1.4/jquery.min.js // Gives you the last '1.4' version (e.g. 1.4.2)
          http://ajax.googleapis.com/ajax/libs/jquery/1.4.2/jquery.min.js // Gives you that exact version
* Discussion afterwards: you'll probably need:
    * Continuous integration
    * Documentation
    * Packages
    * Loader mechanism (see RequireJS, $LAB, etc.)
    * Development mode (by proxy? hosts file?)
    * Cross development (multiple projects working on same code base)
    * Versioning