Fronteers 2010, Day 2
---------------------

## Real-world responsive design - [Stephen Hay](http://www.the-haystack.com) - [@stephenhay](http://twitter.com/stephenhay)
* Platform agnostic vs Platform aware
* Take into consideration the *circumstances* of the user (instead of context)
  Are people behind a desktop, or on a train with a mobile phone?

    > Design is the method of putting form and content together.
    > *Paul Rand*

* Layout != design
* [Mediaquery W3C spec](http://w3.org/TR/css3-mediaqueries)
* Javascript width detection works in every browser [@ppk](http://quirksmode.org) tested:

        document.documentElement.clientWidth

* Mobile first: structured content first (but what will happen if mobile gets better than desktop?)
* [Love nonsense](http://www.lovenonsense.com)
* Clients that say that scrolling in a page is wrong should be told that turning a page in a book is wrong then too
* Zooming on mobile devices is made for legacy websites that aren't optimized for mobile

        <meta name="viewport" content="width=device-width" />

* Means: the layout viewport is the width of the device (and then use media query)
* Resources:
    * [unstoppablerobotninja.com](http://unstoppablerobotninja.com)
    * [quirksmode mobile findings](http://quirksmode.org/blog/archives/mobile/index.html)
    * [The most important presentation about mobile devices](http://slideshare.net/bryanreiger/rethinking-the-mobile-web-by-yiibu)
    * [colly.com](http://colly.com)
* [CSS3 Template layout module](http://www.w3.org/TR/2009/WD-css3-layout-20090402/)
* [CSS3 Template layout jQuery plugin](http://code.google.com/p/css-template-layout)
* CSS3 flexible box layout module

        div {
            display: box;
            box-orient: horizontal / vertical;
        }

* Supported on webkit and gecko
* [bryanreiger.com](http://bryanreiger.com) - server side solution for media queries very soon!
* Ask these questions before designing:
    1. Who is the user?
    2. What is their purpose?
    3. What are their circumstances
    4. What will they (need to) do?
* [wurfl](http://wurfl.sourceforge.net) - mostly information about WAP browsers
* How do you present this to a client? Do you show 10 different resolutions?
    * Design in the browser and present that
    * Hand out moodboards, and don't show designs

## The State of HTML5 - [Paul Irish](http://paulirish.com/) - [@paul_irish](http://twitter.com/#!/paul_irish)
* Device orientation is also in HTML5
* Fallback mechanism when the wifi fails:

        <object data="http://bla.com/difficultthing.svg">
            <object data="fallbackimage"></object>
        </object>

* New features in HTML5:
    * Dependable features (can already be used, in all browsers)
        * doctype
        * charset
        * self-closed tags, optional quotes
        * no more type attributes (text/css, text/javascript)
        * new semantics (using HTML5 shim for IE)
            * [iecss.com](http://iecss.com)
            * [print protector for IE with shim](http://www.iecss.com/print-protector)
        * data-* attributes
        * contenteditable
            * [Using the style tag with contenteditable!](http://annevankesteren.nl/test/contenteditable-style.htm)
    * Roughly usable features
        * audio & video
            * Needs WebM, OGG (drop after Fx 3.6 drops out) and H264
        * canvas
            * [Video to ASCII](http://paulirish.com/workvideo2ascii)
            * [Video ASCII 3d cube](http://studio.html5rocks.com/samples/video-cube/index.html)
        * SVG
        * geolocation
        * web sockets
            * [SocketIO](http://socket.io/) is a good library for this
        * drag n drop
        * input autofocus
        * input placeholder
    * Experimental features
        * form input types
        * `<meter>` & `<progress>`
        * web SQL database
            * [IndexedDB](http://www.w3.org/TR/IndexedDB/) will be implemented in all browsers instead of WebSQL
        * web storage
        * web workers
        * WebGL (in Chrome 7 and Firefox 4)
            * [Fish tank](http://webglsamples.googlecode.com/hg/aquarium/aquarium.html)
        * File API
            * [Drop mocks](http://dropmocks.com)
        * `history.pushstate`
            * Use for indexable urls without page reload
    * Edge features
        * hardware acceleration
        * [IndexedDB](http://www.w3.org/TR/IndexedDB/)
        * orientation (only works with Macbooks right now)
            [Orientation demo](http://jsfiddle.net/JTSug/3/show)
        * `<device>`
            * Access webcam, live video and audio in the browser!
        * audio data API
            * [audio data API demo](http://videos.mozilla.org/serv/blizzard/audio-slideshow)
            * [Implemented in Webkit as well](http://chromium.googlecode.com/svn/trunk/samples/audio/o3d-webgl-samples)
        * `<input speech>`
            * Webkit only currently [demo](http://jsbin.com/icadu4)
        * SVG filters
            * Not in IE9.
            * [demo](http://paulirish.com/work/videooo.xhtml)
            * [everything together](http://code.bocoup.com/audio-data-api/flash-vs-html5)
    * Not in IE6
        * background-attachment: fixed;
        * lots of other stuff :)
    * Not in IE7
        * postMessage
        * cross-domain XHR
        * native JSON
        * data URI
        * `:before`, `:after`, `:focus`
        * `localStorage`, `sessionStorage`
        * getters and setters on DOM elements
        * `querySelector()`, `querySeletorAll()`
        * `box-sizing`
    * [Can i use something in a browser?](http://caniuse.com)
    * Weird, fix using Modernizr

            <input type="email" />
            inputel.getAttribute('type'); // email
            inputel.type // text

    * [Detect touch](http://bit.ly/detecttouch)
    * Regresive enhancement
        * polyfill

            > A shim that mimics a future API providing fallback functionality
            > for older browsers

        * e.g. [gelocation polyfil](http://gist.github.com/36184) or [Flashcanvas](http://flashcanvas.net/docs/canvas-api)
        * [Lots of polyfills](http://github.com/Modernizr/Modernizr/wiki/HTML5-Cross-browser-Polyfills)
    * [New Javascript loader: yepnope.js](http://github.com/SlexAxton/yepnope.js)
    * [hasjs: The canonical detect for all feature detection](http://github.com/phiggins42/has.js/)
    * HTML5 on production websites: yes or no?

## Creating lifelike designs with CSS3 - [Meagan Fisher](http://owltastic.com/) [@owltastic](http://twitter.com/#!/owltastic)
* [No more bullshit. Join the revolution.](http://theleagueofmovabletype.com) And use webfonts.
* [CSS3, Please!](http://css3please.com/)
* Box-shadow doesn't look the same across all browsers, but it's better than
  drawing 3px drop shadows in Photoshop.

## High performance Javascript - [Nicholas Zakas](http://www.nczonline.net/) - [@slicknet](http://twitter.com/#!/slicknet/) - Yahoo - [Slides](http://www.slideshare.net/nzakas/high-performance-javascript-fronteers-2010)
* Principal front end engineer Yahoo homepage
* Javascript performance matters directly for the user experience
* Both browser UI and Javascript is in one browser thread, so slows both down
* The longer you run Javascript, the longer the UI will not respond (runaway script timer prevents this a bit, except for Opera)
* Nielsen: 100ms is the limit for having the user feel that the system is reacting instantly
* Limit JavaScript execution to 50ms (measured in IE6!)
* Using dynamic script loading the download is not blocking the UI thread
* Timer execution is not done after given time, but a task is scheduled
* You can do script execution with timers to give the illusion of a non-blocked UI

        function timedProcessArray() {
            // see slide 97 on slideshare :)
        }

* Another solution to this problem is by using web workers (script execution is not in the UI thread)
    * Mostly useful for data-driven tasks (not DOM / UI), JSON processing etc.
    * Speed of web workers is the same as if you would do blocking JS
    * No JSONP in Web workers! So cross-domain is difficult.
    * Available in all browsers except IE (no word on IE9 support)
    * Data passed to a worker is copied, so there is some duplication of data,
      however, this doesn't happen during the UI thread, so no blocking.
* The nice thing about animations is that they're already using timers, and hence, don't block the UI
* For memory management:
    * Minimize use of closures
    * Use `delete` on object properties
    * Set unused variables to null

## HTML5 Accessibility: Is it ready yet? - [Steve Faulkner](http://www.paciellogroup.com/blog/) & Hans Hillen - The Paceillo Group (TPG)

### Steve Faulkner's part
* [html5accessibility.com](http://html5accessibility.com)
> Accessibility is more than screen readers.
> And not everyone using a screen reader is blind.
* Assistive technology
* HTML5 is not accessible yet
* Browsers provide very little information to accessibility API's on the new HTML5 technologies
* The most accessible browsers are Firefox (Windows), Safari (Mac) and IE.
* Bolt-on vs built-in accessibility
* Opera Mini on iPhone is not accessible
* Accessibility alternatives for `<canvas>`
    * focus ring
    * navigatable sub-dom
    * image map

### Hans Hillen's part
* ARIA Landmark roles
    * Used to defined sections and a page so screen readers can easily
      navigate between those
    * Alternative to using 'skip links'
    * Some of these roles map to HTML5 elements, such as `role="navigation"` does to `<nav>`
    * However, the main problem is that elements can be used multiple times, while roles can't
    * ARIA can be used to make widgets
    * ARIA roles can be combined with HTML5 elements
    * [NVDA](http://nvda-project.com) - Open source screen reader, use in combination with Firefox for a nice test setup for ARIA roles
    * [webaim.org](http://webaim.org) - Good resource for accessibility

## The Renaissance of Browser Animation - [Cameron Adams](http://www.themaninblue.com/) - [@themaninblue](http://twitter.com/themaninblue)
* First animation ever: the Iranian vase
* Very early web animation: Make the monkeys chase one another (Taylor's Dynamic HTML tutorial) on [Webmonkey](http://webmonkey.com)
* Why use animations in your page?
    1. Attention
    2. Narrative
    3. Engaging
    4. Reponsive interfaces
    5. Understandable interfaces
    6. Temporal understanding
    7. Creative expression
* Animations models
    * The Artist (a canvas that is cleared at every frame, single timeline)
    * The Director (multiple timelines, only indicate movement, think sprites)
* Six different ways to animate on the web
    1. HTML/ JS (Director)
    2. CSS3 transformations (Director)
        * Currently only Webkit supports keyframing
    3. SVG (Director)
        * [Blobular](http://www.themaninblue.com/experiment/Blobular/)
        * [Raphaël](http://raphaeljs.com/) (uses VML for IE support)
    4. Canvas (Artist)
        * Use some kind of Sprite queue to do multiple object animations on the same canvas
        * [Flowerpower](http://www.chromeexperiments.com/detail/flowerpower/)
        * [Cake.js](http://code.google.com/p/cakejs/) (brings director-style animation to `<canvas>`), not developed anymore
        * Not that great for mouse interaction (but you might use Processing.js or Cake.js for that)
    5. Flash (Director)
        * [TweenMax](http://www.greensock.com/tweenmax/) library for tweening
    6. WebGL (Artist)
        * Basically 3d canvas. No concept of sprites. Lots of Matrices :)
        * Latest Firefox nightlies have hardware acceleration for WebGL
        * Coppola (??): WebGL gaming framework
        * Library: [three.js](http://github.com/mrdoob/three.js) (uses Canvas and SVG if no WebGL is present) (not to be confused with the [3JS's](http://www.3js.nl/) :)
* Select one of these frameworks by
    * Performance
        * Animations at 3 fps are not very cool
        * Benchmarking: done using particle generator for SVG, Canvas, Flash and HTML/JS
            * On Fx / Mac
            1. Flash
            2. Canvas
            3. Html
            4. SVG
        * On Safari / Mac are less clear
        * On iPad HTML/Canvas is too slow, with CSS transitions it might work
    * Compatibility
        * CSS3 is probably the most degradable technology
    * Interactivity
        * Boxes vs Shapes
    * Completeness
    * Workflow
    * Acessibility

## Reasons to be cheerful - [Chris Heilmann](http://www.wait-till-i.com/) [@codepo8](http://twitter.com/codepo8) - [Slides](http://www.slideshare.net/cheilmann/reasons-to-be-cheerful-fronteers-2010)
(This wasn't a tech presentation, and hard to take notes, but really good anyway. You should definitely watch the video!)

* Learning HTML, some nice resources
    * [Opera Web standards cv](http://dev.opera.com/articles/wsc)
    * [Webstandards interact](http://interact.webstandards.org)
    * [developer.mozilla.org](http://developer.mozilla.org)
    * [yuiblog.com/crockford](http://yuiblog.com/crockford)
    * [developer-evangelism.com](http://developer-evangelism.com)

> If you say you're open and your code is not on github you're not open

.

> Libraries fix browsers

Not

> I'm a frontend/web/interaction/blabla designer

But:

> I build stuff for the internet

.

> Most innovation on the web is put in without requests from above.

* "Silver surfers": web users above 50
* [YUI/Express JS demo](http://express.davglass.com/) turn off Javascript to see the effect!